"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
document.addEventListener("DOMContentLoaded", () => {
    const posts = document.getElementById("posts");
    const firstName = document.getElementById("firstName");
    const lastName = document.getElementById("lastName");
    const inputFirstName = document.getElementById("inputFirstName");
    const inputLastName = document.getElementById("inputLastName");
    const inputEmail = document.getElementById("inputEmail");
    const inputPost = document.getElementById("inputPost");
    const formSend = document.getElementById("form_send");
    const changeProfile = document.getElementById("change_profile");
    const followUser = document.getElementById("follow_user");
    const profileModal = document.getElementById("profile_modal");
    const followUserModal = document.getElementById("follow_user_modal");
    const profileModalForm = document.getElementById("profile_modal_form");
    const followUserModalForm = document.getElementById("follow_user_modal_form");
    const values = { firstName: "", lastName: "", email: "", post: "" };
    const parseGetData = ({ url, isGet, data }) => __awaiter(void 0, void 0, void 0, function* () {
        return isGet ?
            yield (yield fetch(url)).json() :
            yield (yield fetch(url, { method: "POST", headers: { "Content-Type": "application/x-www-form-urlencoded" }, body: new URLSearchParams(data) })).json();
    });
    const createElem = ({ fullName, message }) => {
        const div = document.createElement("div");
        div.setAttribute("class", "post");
        div.innerHTML = `<div class="author">${fullName} said:</div><div class="message">${message}</div>`;
        return div;
    };
    class Profile {
        constructor() {
            this.firstName = "";
            this.lastName = "";
            this.email = "adam@gmail.com";
            this.registerProfile();
        }
        ;
        registerProfile() {
            return __awaiter(this, void 0, void 0, function* () {
                const res = yield parseGetData({ url: `http://146.185.154.90:8000/blog/${this.email}/profile`, isGet: true });
                this.firstName = res.firstName;
                this.lastName = res.lastName;
            });
        }
        ;
        changeProfile({ firstName, lastName }) {
            return __awaiter(this, void 0, void 0, function* () {
                const obj = { firstName, lastName };
                const res = yield parseGetData({ url: `http://146.185.154.90:8000/blog/${this.email}/profile`, isGet: false, data: obj });
                this.firstName = res.firstName;
                this.lastName = res.lastName;
            });
        }
        ;
        subscribe(email) {
            return __awaiter(this, void 0, void 0, function* () {
                yield parseGetData({ url: `http://146.185.154.90:8000/blog/${this.email}/subscribe`, isGet: false, data: { email } });
            });
        }
        ;
    }
    ;
    class Post extends Profile {
        constructor() {
            super();
            this.lastDate = null;
            this.getPosts();
            setInterval(() => {
                if (this.lastDate) {
                    this.getLastPosts();
                }
                ;
            }, 2000);
        }
        ;
        getPosts() {
            return __awaiter(this, void 0, void 0, function* () {
                const res = yield parseGetData({ url: `http://146.185.154.90:8000/blog/${this.email}/posts`, isGet: true });
                this.lastDate = res.reverse().shift().datetime;
                res.forEach((item) => {
                    posts === null || posts === void 0 ? void 0 : posts.append(createElem({ fullName: `${item.user.firstName} ${item.user.lastName}`, message: item.message }));
                });
            });
        }
        ;
        getLastPosts() {
            return __awaiter(this, void 0, void 0, function* () {
                const res = yield parseGetData({ url: `http://146.185.154.90:8000/blog/${this.email}/posts?datetime=${this.lastDate}`, isGet: true });
                if (res.length !== 0) {
                    this.lastDate = res[0].datetime;
                    posts === null || posts === void 0 ? void 0 : posts.append(createElem({ fullName: `${res[0].user.firstName} ${res[0].user.lastName}`, message: res[0].message }));
                }
            });
        }
        ;
        createPost(message) {
            return __awaiter(this, void 0, void 0, function* () {
                yield parseGetData({ url: `http://146.185.154.90:8000/blog/${this.email}/posts`, isGet: false, data: { message } });
            });
        }
        ;
    }
    ;
    const profile = new Profile();
    const post = new Post();
    changeProfile === null || changeProfile === void 0 ? void 0 : changeProfile.addEventListener("click", () => {
        profileModal && (profileModal.style.display = "block");
    });
    inputFirstName === null || inputFirstName === void 0 ? void 0 : inputFirstName.addEventListener("change", (e) => {
        values.firstName = e.target.value;
    });
    inputLastName === null || inputLastName === void 0 ? void 0 : inputLastName.addEventListener("change", (e) => {
        values.lastName = e.target.value;
    });
    inputEmail === null || inputEmail === void 0 ? void 0 : inputEmail.addEventListener("change", (e) => {
        values.email = e.target.value;
    });
    inputPost === null || inputPost === void 0 ? void 0 : inputPost.addEventListener("change", (e) => {
        values.post = e.target.value;
    });
    profileModalForm === null || profileModalForm === void 0 ? void 0 : profileModalForm.addEventListener("submit", (e) => {
        e.preventDefault();
        profile.changeProfile({ firstName: values.firstName, lastName: values.lastName });
        firstName.innerText = values.firstName;
        lastName.innerText = values.lastName;
        profileModal.style.display = "none";
    });
    followUser === null || followUser === void 0 ? void 0 : followUser.addEventListener("click", () => {
        followUserModal.style.display = "block";
    });
    followUserModalForm === null || followUserModalForm === void 0 ? void 0 : followUserModalForm.addEventListener("submit", (e) => {
        e.preventDefault();
        profile.subscribe(values.email);
        followUserModal.style.display = "none";
    });
    formSend === null || formSend === void 0 ? void 0 : formSend.addEventListener("submit", (e) => {
        e.preventDefault();
        post.createPost(values.post);
    });
});
